'Broadcom LAN Driver install Script
'Version BCM.01.15

'---------------------------------
'C
'---------------------------------
'Version B.01.00 (2010/12/07)
'  EVK

'Version B.01.01 (2010/12/14)
'  EspX擾objShell.CurrentDirectory
'    WScript.ScriptFullNameɕύX

'Version BCM.01.02 (2011/01/25)
'  EXNvgo[W̕ύX
'  EOtΉ
'  ELogi[tH_̕ύX
'  EbZ[W̕ύX
'  EBACS̃CXg[ς݃`FbN̒ǉ
'  E1G/10G NIChCoCXg[ǉ

'Version BCM.01.03 (2011/02/17)
'  EXNvgo[W̕ύX
'  ELegacyVlanStats=1ǉ
'  ELOM:14.6.4.1, NIC:6.2.4.1, BACS:6.2.4.1

'Version BCM.01.04 (2011/10/13)
'  ELOM:15.0.3.2, NIC:7.0.2.10, BACS:15.0.3.2

'Version BCM.01.05 (2011/11/10)
'  ELOM:15.0.3.4, NIC:7.0.2.14, BACS:15.0.3.4

'Version BCM.01.06 (2011/11/16)
'  ELOM:15.0.4.1, NIC:7.0.2.14, BACS:15.0.4.1
'  EAdd RxMaxCoalesced=0

'Version BCM.01.07 (2011/12/12)
'  ENIC:7.0.4.1

'Version BCM.01.08 (2011/12/19)
'  ENIC:7.0.4.2

'Version BCM.01.09 (2011/12/20)
'  E5719 Tx Hang(LSO Off)ǉ

'Version BCM.01.10 (2011/12/26)
'  ENIC:7.0.4.3

'Version BCM.01.11 (2012/2/10)
'  ENIC:7.0.4.4

'Version BCM.01.12 (2012/3/2)
'  E15.0.4.2 BACSΉ

'Version BCM.01.13 (2012/9/24)
'  EWS2012Ή

'Version BCM.01.14 (2012/9/24)
'  EWS2012Ή

'Version BCM.01.15 (2013/4/5)
'  Epgdyavd.exes@ύX

'---------------------------------
'---------------------------------
Option Explicit

'---------------------------------
'ScriptShellp̐ݒ
'---------------------------------
Dim objShell, objFS, ExePath

Set objShell    = WScript.CreateObject("Wscript.Shell")
Set objFS       = WScript.CreateObject("Scripting.FileSystemObject")
ExePath         = WScript.ScriptFullName 
ExePath         = left(ExePath,len(ExePath)-len(WScript.ScriptName)-1) 

'---------------------------------
'START
'---------------------------------
Dim WINDIR, LOGDIR, DRLOGFILENAME, NICDRLOGFILENAME, SCLOGFILENAME, DrvCmd, NICDrvCmd, objexec, InsOpt, InsOpt2, Msg, Err_Flag, LogFile, strArgPlat, FullName, RegSet

WINDIR          = objShell.ExpandEnvironmentStrings("%windir%")
LOGDIR          = WINDIR & "\$SYSUP$\LOG\LAN"
DRLOGFILENAME   = "BCOMDRV.LOG"
NICDRLOGFILENAME= "BCOMNICDRV.LOG"
SCLOGFILENAME   = "INSTSCRP.LOG"
Err_Flag        = 0

'--------------------
'sIvV
'--------------------
InsOpt   = "/s /v" & chr(&H22) & "/qn REBOOT=ReallySuppress" & " " & "/L" & " " & LOGDIR & "\" 
InsOpt2  = "-s" & " " & LOGDIR & "\"

'-------------------
'Log̃tH_쐬
'-------------------
If objFS.FolderExists(LOGDIR) = False Then
    objFS.Createfolder(LOGDIR)
End If

'--------------
'̃`FbN
'--------------
If WScript.Arguments.Count = 0 Then
    Msg = "No Options specified"
    Err_Flag = 1
End If

If Err_Flag = 0 Then
    '----------------------
    'Plat.擾
    '----------------------
    strArgPlat = WScript.Arguments.Named("Plat")


    '-----------
    '̏
    '-----------
    If (strArgPlat="2012") Then

        DrvCmd     = ExePath & "\bcom\DrvInst\15040401\x64\setup.exe " & InsOpt & DRLOGFILENAME & chr(&H22)
        NICDrvCmd  = ExePath & "\bcom\DrvInst\07040401\Windows_64\DrvInst\setup.exe " & InsOpt & NICDRLOGFILENAME & chr(&H22)
        RegSet     = ExePath & "\pgdyavd.exe " & InsOpt2

    Else

        Msg = "Installation Aborted. UnKnown Install Option:" & strArgPlat
        Err_Flag = 1

    End If
End If

If Err_Flag = 0 Then

        '------------------
        'LOM Driver Install
        '------------------
        Set objexec = objShell.exec(DrvCmd) 
        Do While objexec.Status = 0
            WScript.Sleep 1000
        Loop

        WScript.Sleep 5000

        '------------------
        'NIC Driver Install
        '------------------
        Set objexec = objShell.exec(NICDrvCmd) 
        Do While objexec.Status = 0
            WScript.Sleep 1000
        Loop

        WScript.Sleep 5000

        '-------------------------------------------
        'Add LegacyVlanStats=1 & BlackHoleRD Disable
        '-------------------------------------------
        On Error Resume Next
        objShell.RegWrite "HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services\tcpip\parameters\EnablePMTUBHDetect", 0, "REG_DWORD"

        Msg = "Installation Executed on Windows " & strArgPlat & " Platform."

        WScript.Sleep 2000

        '---------------------
        'Add RxMaxCoalesced=0
        '---------------------
        Set objexec = objShell.exec(RegSet) 
        Do While objexec.Status = 0
            WScript.Sleep 1000
        Loop

        WScript.Sleep 2000

End If

'--------
'Message
'--------
If objFS.FileExists(LOGDIR & "\" & SCLOGFILENAME) = False Then
    objFS.CreateTextFile(LOGDIR & "\" & SCLOGFILENAME)
End If

Set LogFile = objFS.OpenTextFile(LOGDIR & "\" & SCLOGFILENAME, 8, True)
LogFile.WriteLine(Now)
LogFile.WriteLine(Msg)
LogFile.WriteLine()
LogFile.Close()

'--------------
'Close Object
'--------------
Set objShell = nothing
Set objFS    = nothing
Set objexec  = nothing
Set LogFile  = nothing

'--------------
'Exit Script
'--------------
WScript.Quit(Err_Flag)


